<script setup lang="ts">
import { RouterLink } from 'vue-router'
import { onMounted, ref } from 'vue'
import type Category from '@/models/Category'
import { useApi } from '@/api'
import { onClickOutside } from '@vueuse/core'

defineProps<{
  isMobileOpen: boolean
}>()

const emit = defineEmits(['onMobileClose'])

function onCloseMenu(): void {
  emit('onMobileClose')
}
const { getCategories } = useApi()

const categories = ref<Category[]>([])
const target = ref(null)

onClickOutside(target, () => emit('onMobileClose'))

onMounted(async () => {
  categories.value = await getCategories()
})
</script>
<template>
  <div class="axil-mainmenu" ref="target">
    <div class="container">
      <div class="header-navbar">
        <div class="header-main-nav" :class="{open: isMobileOpen}">
          <!-- Start Mainmanu Nav -->
          <nav class="mainmenu-nav">
            <button class="mobile-close-btn mobile-nav-toggler" @click.prevent.stop="onCloseMenu">
              <i class="fas fa-times"></i>
            </button>
            <div class="mobile-nav-brand">
              <RouterLink :to="{ name: 'home' }" class="logo">
                <img src="@/assets/images/logo/logo.png" alt="Site Logo">
              </RouterLink>
            </div>
            <ul class="mainmenu">
              <li>
                <RouterLink :to="{ name: 'home' }">
                  Home
                </RouterLink>
              </li>
              <li class="menu-item-has-children">
                <RouterLink :to="{ name: 'catalog' }">
                  Catalog
                </RouterLink>
                <ul class="axil-submenu">
                  <li v-for="category of categories" :key="category.id">
                    <RouterLink :to="{ name: 'category', params: { category: category.slug } }">
                      {{ category.title }}
                    </RouterLink>
                  </li>
                </ul>
              </li>
              <li>
                <RouterLink :to="{ name: 'about' }">
                  About
                </RouterLink>
              </li>
              <li>
                <RouterLink :to="{ name: 'blog' }">
                  Blog
                </RouterLink>
              </li>
              <li>
                <RouterLink :to="{ name: 'contacts' }">
                  Contacts
                </RouterLink>
              </li>
            </ul>
          </nav>
          <!-- End Mainmanu Nav -->
        </div>
      </div>
    </div>
  </div>
</template>
